<?php
/**
 * Plugin Name: Chatty - Live Chat Plugin for WordPress (buzzgfx.com)
 * Plugin URI: http://www.persianscript.ir/
 * Description: A simple WordPress Live Chat plugin.
 * Author: OriginalEXE
 * Author URI: http://www.persianscript.ir/
 * Version: 1.0
 */

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) )
	exit;

// Check if class apready exists
if ( ! class_exists( 'Chatty' ) ) :

final class Chatty {

	// Will hold the only instance of our main plugin class
	private static $instance;

	// Used for checking if chat is already running
	private static $running;

	// Holds author name
	public static $author;

	// Holds user id
	public static $author_id;

	// Method for settign running
	public function running() {

		if ( ! isset( self::$running ) ) {

			self::$running = true;

			return false;

		} else {

			return true;

		}

	}

	// Used for setting author name
	public function author( $author ) {

		if ( $author )
			self::$author = $author;
		else
			return self::$author;

	}

	// Used for setting author id
	public function author_id( $author_id ) {

		if ( $author_id )
			self::$author_id = $author_id;
		else
			return self::$author_id;

	}

	// Instantiate he class and set up stuff
	public static function instantiate() {

		if ( ! isset( self::$instance ) && ! ( self::$instance instanceof Chatty ) ) {

			self::$instance = new Chatty;
			self::$instance->define_constants();
			self::$instance->include_files();
			self::$instance->load_textdomain();

		}

		return self::$instance;

	}

	// Used for loading textdomain
	public function load_textdomain() {

		load_plugin_textdomain( 'chatty', false, basename(dirname( __FILE__ )) . '/languages' );

	}

	// Defines plugin constants
	public function define_constants() {

		// Plugin version
		if ( ! defined( 'CHATTY_VER' ) )
			define( 'CHATTY_VER', '0.0.1' );

		// Plugin Folder Path
		if ( ! defined( 'CHATTY_PLUGIN_DIR' ) )
			define( 'CHATTY_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );

		// Plugin Include Path
		if ( ! defined( 'CHATTY_PLUGIN_DIR_INC' ) )
			define( 'CHATTY_PLUGIN_DIR_INC', CHATTY_PLUGIN_DIR . 'includes/' );


		// Plugin Folder URL
		if ( ! defined( 'CHATTY_PLUGIN_URL' ) )
			define( 'CHATTY_PLUGIN_URL', plugin_dir_url( __FILE__ ) );

		// Plugin Root File
		if ( ! defined( 'CHATTY_PLUGIN_FILE' ) )
			define( 'CHATTY_PLUGIN_FILE', __FILE__ );

	}

	// Includes necessary files
	public function include_files() {

		if ( is_admin() ) {

		}

		require_once CHATTY_PLUGIN_DIR_INC . 'actions.php';
		require_once CHATTY_PLUGIN_DIR_INC . 'account-manage.php';
		require_once CHATTY_PLUGIN_DIR_INC . 'author.php';
		require_once CHATTY_PLUGIN_DIR_INC . 'content-output.php';
		require_once CHATTY_PLUGIN_DIR_INC . 'scripts-styles.php';
		require_once CHATTY_PLUGIN_DIR_INC . 'shortcodes.php';

	}

}

endif; // End "if class exists" check

$chatty = Chatty::instantiate();