<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) )
	exit;

class Chatty_Author {

	public function __construct() {

		add_action( 'init', array( $this, 'set_author' ) );

	}

	// Get/set author info on init
	public function set_author() {

		global $chatty;

		if ( is_user_logged_in() ) {
		
			$msg_author = wp_get_current_user();
			$msg_author_display = $msg_author->display_name;
			$msg_author_id = $msg_author->ID;
			
		} else {

			$rand = rand( 1234, 32767 );

			if ( isset( $_COOKIE['chatty_nick'] ) ) {

				if ( false === ( $transient = get_transient( 'chatty_user_' . ( absint( $_COOKIE['chatty_nick'] ) / 2 - 273 ) ) ) ) {

					setcookie( 'chatty_nick', $rand, time() + ( 60*60*12*7 ) );

					set_transient( 'chatty_user_' . ( $rand / 2 - 273 ), $rand - 273, 60*60*12 );

					$msg_author_anon = $rand / 2 - 273;

				} else {

					$msg_author_anon = $_COOKIE['chatty_nick'];

				}

			} else {

				setcookie( 'chatty_nick', $rand / 2 - 273, time() + ( 60*60*12*7 ) );

				set_transient( 'chatty_user_' . ( $rand / 2 - 273 ), $rand / 2 - 273, 60*60*12 );

				$msg_author_anon = $rand / 2 - 273;

			}
		
			$msg_author_display = __( 'Anonymous', 'chatty' ) . $msg_author_anon;


			$msg_author_id = 0;
		
		}

		$chatty->author( $msg_author_display );
		$chatty->author_id( $msg_author_id );

	}

}

new Chatty_Author();