<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) )
	exit;


class Chatty_Content_Output {


	// Used for outputting chat data to frontend
	public static function chatty_output( $id, $storage = 999, $log = 999 ) {

		$chatty_html = '';
		
		$chatty_msgs_log = get_option( 'chatty-chat-' . $id, array() );
		
		$chatty_msgs_count = count( ( array ) $chatty_msgs_log );

		if ( $chatty_msgs_count > $storage ) {

			$temp_count = $chatty_msgs_count - 1;

			while ( ( $temp_count + 1 ) != $storage ) {

				unset( $chatty_msgs_log[ $chatty_msgs_count - $temp_count ] );
				$temp_count--;

			}

			$chatty_msgs_log = array_values( $chatty_msgs_log );

			update_option( 'chatty-chat-' . $id, $chatty_msgs_log );

		} else {

			$temp_count = $chatty_msgs_count - 1;

		}
		
		$chatty_msgs = $chatty_msgs_log;
		
		// join messages of the same author
		for ( $i = 1; $i <= $temp_count; $i++ ) {
		
			if ( $chatty_msgs[ $i ]['a'] === $chatty_msgs[ $i - 1 ]['a'] ) {
			
				$chatty_msgs[ $i ]['m'] = $chatty_msgs[ $i - 1 ]['m'] . '</div>' . '<div class="chatty-time">' . $chatty_msgs[ $i ]['t'] . '</div><div class="chatty-msg">' . $chatty_msgs[ $i ]['m'];
				
				unset( $chatty_msgs[ $i - 1 ] );
			
			}
		
		}
		
		$chatty_msgs = array_values( $chatty_msgs );
		
		$chatty_history = '';
		
		foreach ( $chatty_msgs as $chatty_msg ) {
			
			$chatty_history .= '<div class="chatty-bubble">';
			
			$chatty_history .= '<div class="chatty-avatar">' . $chatty_msg['av'] . '</div>';
			$chatty_history .= '<div class="chatty-author">' . $chatty_msg['a'] . '</div>';
			$chatty_history .= '<div class="chatty-time">' . $chatty_msg['t'] . '</div>';
			$chatty_history .= '<div class="chatty-msg">' . $chatty_msg['m'] . '</div>';
			
			$chatty_history .= '</div>';
			
		}
			
		$chatty_html .= stripslashes( $chatty_history );

		return $chatty_html;

	}

}