<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) )
	exit;

class Chatty_Scripts_Styles {

	public function __construct() {

		add_action( 'wp_enqueue_scripts', array( $this, 'scripts_styles_print_frontend' ) );

	}


// function responsible for outputting custom js and css to the page
	public function scripts_styles_print_frontend() {

		global $chatty;

		wp_register_style( 'oe_cht_customcss_emoticons', CHATTY_PLUGIN_URL . 'css/jquery.cssemoticons.css', false, CHATTY_VER );
		wp_register_style( 'oe_cht_customcss_open_sans', '//fonts.googleapis.com/css?family=Open+Sans', false, CHATTY_VER );
		wp_enqueue_style( 'oe_cht_customcss_frontend', CHATTY_PLUGIN_URL . 'css/frontend.css', array( 'oe_cht_customcss_open_sans', 'oe_cht_customcss_emoticons' ), CHATTY_VER );
		

		$ajax_nonce = wp_create_nonce( 'chatty_nonce' );


		wp_register_script( 'oe_cht_customjs_emoticons', CHATTY_PLUGIN_URL . 'js/jquery.cssemoticons.min.js', array( 'jquery' ), CHATTY_VER );
		wp_register_script( 'oe_cht_customjs_linkify', CHATTY_PLUGIN_URL . 'js/linkify-modified.js', false, CHATTY_VER );
		wp_enqueue_script( 'oe_cht_customjs_frontend', CHATTY_PLUGIN_URL . 'js/frontend.js', array( 'oe_cht_customjs_linkify', 'oe_cht_customjs_emoticons' ), CHATTY_VER );
		
		// load options
				
		$localization_array = array( 
			'ajaxurl'  => admin_url( 'admin-ajax.php' ),
			'nonce'    => $ajax_nonce,
			'author'   => $chatty->author( false ),
			'time'     => time(),
			'uid'      => $chatty->author_id( false ),
		);
		
		wp_localize_script( 'oe_cht_customjs_frontend', 'customjsAjax', $localization_array );
		
	}

}

new Chatty_Scripts_Styles();