<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) )
	exit;

class Chatty_Shortcodes {

	public function __construct() {

		add_action( 'init', array( $this, 'register_shortcodes' ) );

	}

	public function register_shortcodes() {

		add_shortcode( 'chatty', array( $this, 'chatty_init' ) );

	}

	// Responsible for handling shortcode output
	public function chatty_init( $atts ) {

		global $chatty;

		if ( $chatty->running() ) {
			echo '<p>' . __( 'One instance of Chatty per url is allowed, stopping output to avoid issues.', 'chatty' ) . '</p>';

			return;

		}
			
		extract( shortcode_atts( array(
			'allow_guests' => 1,
			'height'       => 400,
			'id'           => 101,
			'storage'      => 999,
			'log'          => 999,
			'interval'     => 5,
		), $atts ) );

		if ( ! $allow_guests ) {

			if ( ! is_user_logged_in() ) {

				echo Chatty_Account_Manage::login_required();

				return;

			}

		}
		
		$output = '<div class="chatty-wrapper" data-interval="' . $interval . '"><div class="chatty-wrap" style="height:' . $height . 'px;">' . Chatty_Content_Output::chatty_output( $id, $storage, $log ) . '</div>';
		$output .= '<input type="text" name="' . $id . '" class="chatty-textarea"><button class="chatty-submit" type="submit">' . __( 'Send', 'chatty' ) . '</button>';
		$output .= '<div class="chatty-status"></div>' .  Chatty_Account_Manage::output() . '</div>';
		
		echo $output;
		
	}

}

new Chatty_Shortcodes();

