(function($) {

	var chattySubmit,
		messagesWrap,
		textarea,
		id,
		status,
		statusTimeout,
		refreshInterval,
		getInterval;

	function chattyDateTime() {

		var d = new Date(),
			serverTime = customjsAjax.time,
			clientTime = Math.round( d.getTime() / 1000 ),
			calcTime;
		
		calcTime = serverTime - clientTime;
		
		d.setTime( ( serverTime  ) * 1000 );

		d = new Date();
		
		return d.toLocaleTimeString();
		
	}

	function chattyPost( id, msg, author, time ) {
		
		jQuery.post(
			
			customjsAjax.ajaxurl,
			{
			
				action : 'chatty_post',
				nonce  : customjsAjax.nonce,
				id     : id,
				msg    : msg,
				author : author,
				uid    : customjsAjax.uid,
				time   : time
				
			},
			
			function( chattyResponse ) {
				
				chattyGet( id );
				
			},
			
			'JSON'
			
		);

	}

	function chattyGet( id ) {

		$.post(
			
			customjsAjax.ajaxurl,
			{

				action : 'chatty_get',
				nonce  : customjsAjax.nonce,
				id     : id
				
			},
			
			function( chattyResponse ) {

				// emoticonize the output
				var temp = $( '<div/>' );

				temp.html( chattyResponse ).find('.chatty-msg').each( function() {
					$( this ).emoticonize({ animate : false });

					var html = $( this ).html();

					html = chatty_linkify( html );

					$( this ).html( html );

				});

				messagesWrap.html( temp );

				var position = messagesWrap.scrollTop();

				//if ( position + messagesWrap.height() + 150 >= messagesWrap.children( 'div' ).height() )
				if ( 1 )
					messagesWrap.animate({scrollTop: messagesWrap.prop("scrollHeight")}, 0);
				
			},
			
			'JSON'
			
		);

	}

	$( document ).ready( function() {
		
		chattySubmit    = $( '.chatty-submit' ),
		messagesWrap    = $( '.chatty-wrap' ),
		textarea        = chattySubmit.siblings( 'input' ),
		id              = textarea.attr( 'name' ),
		status          = $( '.chatty-status' ),
		refreshInterval = parseInt( $( '.chatty-wrapper' ).attr( 'data-interval' ), 10 ) * 1000;
		
		chattySubmit.click( function() {

			var msg  = textarea.val(),
				time = chattyDateTime();
			
			if ( msg !== '' ) {
			
				chattyPost( id, msg, customjsAjax.author, time );
				
				textarea.val( '' );
			
			} else {
			
				textarea.focus();
				
				status.text( 'At least write something before sending...' );
				
				status.fadeIn();
				
				clearTimeout( statusTimeout );
				
				statusTimeout = setTimeout(function() {
					
					status.fadeOut();
					
				}, 5000);
				
			}
			
			return false;
			
		});
		
		getInterval = setInterval(function() {
					
			chattyGet( id );
					
		}, refreshInterval );
		
		messagesWrap.animate({scrollTop: messagesWrap.prop("scrollHeight")}, 0);

		// Emoticonize starting html:
		$('.chatty-msg').each( function() {
			$( this ).emoticonize({ animate : false });

			var html = $( this ).html();

			html = chatty_linkify( html );

			$( this ).html( html );

		});

		// If enter is pressed, send the message
		$( '.chatty-textarea' ).on( 'keypress', function(e) {

			if( e.which === 13 ) {

				$( this ).siblings( '.chatty-submit' ).click();

			}

		});
		
	});

})(jQuery);